
#include <stdio.h>
#include <stdlib.h>

#include <ardrone_tool/ardrone_time.h>
#include <ardrone_tool/Control/ardrone_control_ack.h>
#include <ardrone_tool/UI/ardrone_input.h>
#include <ardrone_tool/Com/config_com.h>

#include <ardrone_tool/ardrone_tool.h>
#include <ardrone_tool/Control/ardrone_control.h>
#include <ardrone_tool/Navdata/ardrone_navdata_client.h>

#include <VP_Os/vp_os_malloc.h>
#include <VP_Os/vp_os_print.h>
#include <VP_Api/vp_api_thread_helper.h>
#include <VP_Com/vp_com.h>

// XPȑO̊̏ꍇ́CPthread for Win32gD
#include <VP_Os/vp_os_signal.h>
#if defined USE_PTHREAD_FOR_WIN32
	#pragma comment (lib,"pthreadVC2.lib")
#endif


/*---------------------------------------------------------------------------------------------------------------------
O[oϐ
---------------------------------------------------------------------------------------------------------------------*/

// ARDroneIPAhX
char wifi_ardrone_ip[256] = { WIFI_ARDRONE_IP };	

static int32_t	MiscVar[NB_MISC_VARS] = {
										DEFAULT_MISC1_VALUE, 
										DEFAULT_MISC2_VALUE,
										DEFAULT_MISC3_VALUE, 
										DEFAULT_MISC4_VALUE
										};

static bool_t			need_update = TRUE;
static ardrone_timer_t	ardrone_tool_timer;
static int				ArdroneToolRefreshTimeInMs = ARDRONE_REFRESH_MS;
static int32_t			configure_index = 0;
static bool_t			send_com_watchdog = FALSE;
static ardrone_control_ack_event_t	ack_config;


// tCgJnOɑp[^
// ɃZbgꂽƂmF邽߂ɂPF𓾂đD
static ardrone_tool_configure_data_t configure_data[] = {
	{ "general:navdata_demo", "FALSE" },
	{ NULL, NULL }
};


/*---------------------------------------------------------------------------------------------------------------------
ArDroneLibŒ`ׂCRpC̖肪ĂŒ`D
---------------------------------------------------------------------------------------------------------------------*/
unsigned long bswap(unsigned long x)
{
	return _byteswap_ulong(x);
}

int clz(unsigned long x)
{
	// Barbarian counting method if no instrinsic is available
	int i; const int L=sizeof(x)*8-1;
	const unsigned long mask = ( 1 << L );
	if (x==0) { return L+1; }
	for (i=0;i<L;i++) { if (x&mask) return i; x<<=1; } 
	return i;
}


/*---------------------------------------------------------------------------------------------------------------------
L[vACuR}hARDroneɑ
---------------------------------------------------------------------------------------------------------------------*/
void ardrone_tool_send_com_watchdog( void )
{
	send_com_watchdog = TRUE;
}


/*---------------------------------------------------------------------------------------------------------------------
ardrone_tool_configure()ƂꎩgŎgR[obN֐D
̊֐ARDronẽp[^SɃZbg邽߂ɁC
DroneRg[\PbgƏFVXegD
p[^configure_dataɊi[D
---------------------------------------------------------------------------------------------------------------------*/
static void ardrone_tool_end_configure( struct _ardrone_control_event_t* event )
{
	if ( event->status == ARDRONE_CONTROL_EVENT_FINISH_SUCCESS )
		configure_index ++;

	if ( configure_data[configure_index].var != NULL && configure_data[configure_index].value != NULL ) {
		ack_config.event                        = ACK_CONTROL_MODE;
		ack_config.num_retries                  = 20;
		ack_config.status                       = ARDRONE_CONTROL_EVENT_WAITING;
		ack_config.ardrone_control_event_start  = NULL;
		ack_config.ardrone_control_event_end    = ardrone_tool_end_configure;
		ack_config.ack_state                    = ACK_COMMAND_MASK_TRUE;

		ardrone_at_set_toy_configuration( configure_data[configure_index].var, configure_data[configure_index].value );
		ardrone_at_send();

		ardrone_control_send_event( (ardrone_control_event_t*)&ack_config );
	}
}


/*---------------------------------------------------------------------------------------------------------------------
ARDrone Tool̐ݒ
---------------------------------------------------------------------------------------------------------------------*/
static C_RESULT ardrone_tool_configure()
{
	if ( configure_data[configure_index].var != NULL && configure_data[configure_index].value != NULL ) {
		ack_config.event                        = ACK_CONTROL_MODE;
		ack_config.num_retries                  = 20;
		ack_config.status                       = ARDRONE_CONTROL_EVENT_WAITING;
		ack_config.ardrone_control_event_start  = NULL;
		ack_config.ardrone_control_event_end    = ardrone_tool_end_configure;
		ack_config.ack_state                    = ACK_COMMAND_MASK_TRUE;

		ardrone_at_set_toy_configuration( configure_data[configure_index].var, configure_data[configure_index].value );
		ardrone_at_send();

		ardrone_control_send_event( (ardrone_control_event_t*)&ack_config );
	}

	return C_OK;
}


/*---------------------------------------------------------------------------------------------------------------------
ARDrone Tool̃ZbgAbv
---------------------------------------------------------------------------------------------------------------------*/
C_RESULT ardrone_tool_setup_com( const char* ssid )
{
	C_RESULT res = C_OK;

	vp_com_init(COM_NAVDATA());
	vp_com_local_config(COM_NAVDATA(), COM_CONFIG_NAVDATA());
	vp_com_connect(COM_NAVDATA(), COM_CONNECTION_NAVDATA(), NUM_ATTEMPTS);
	((vp_com_wifi_connection_t*)wifi_connection())->is_up = 1;
	return res;
}


/*---------------------------------------------------------------------------------------------------------------------
ARDrone Tool̏
---------------------------------------------------------------------------------------------------------------------*/
C_RESULT ardrone_tool_init(int argc, char **argv)
{
	C_RESULT res;

	//Fill structure AT codec and built the library AT commands.
	ardrone_at_init( wifi_ardrone_ip, strlen( wifi_ardrone_ip) );

	// TuVXȅ
	ardrone_timer_reset(&ardrone_tool_timer);
	ardrone_tool_input_init();
	ardrone_control_init();
	ardrone_navdata_client_init();

	// JX^c[̏
	res = ardrone_tool_init_custom(argc, argv);	// ̊֐custom_code.cŒ`ĂD

	// AT|[g̃I[v
	ardrone_at_open();

	START_THREAD(navdata_update, 0);
	START_THREAD(ardrone_control, 0);

	ardrone_tool_configure();

	// X^[gAbvݒ̑M
	ardrone_at_set_pmode( MiscVar[0] );
	ardrone_at_set_ui_misc( MiscVar[0], MiscVar[1], MiscVar[2], MiscVar[3] );

	return res;
}


/*---------------------------------------------------------------------------------------------------------------------
ATR}hNCAg̍XViC[v̂悤Ȃ́j
---------------------------------------------------------------------------------------------------------------------*/
C_RESULT ardrone_tool_update()
{
	int delta;
	C_RESULT res = C_OK;

	// TuVXeƃJX^c[̍XV
	if ( need_update ) {
		ardrone_timer_update(&ardrone_tool_timer);
		ardrone_tool_input_update();
		res = ardrone_tool_update_custom();

		if ( send_com_watchdog == TRUE ) {
			ardrone_at_reset_com_watchdog();
			send_com_watchdog = FALSE;
		}
		// Send all pushed messages
		ardrone_at_send();
		need_update = FALSE;
	}

	delta = ardrone_timer_delta_ms(&ardrone_tool_timer);
	if ( delta >= ArdroneToolRefreshTimeInMs) {
		res = ardrone_tool_display_custom();
		need_update = TRUE;
	}
	else {
		Sleep((ArdroneToolRefreshTimeInMs - delta));
	}

	return res;
}


/*---------------------------------------------------------------------------------------------------------------------
ARDrone̐TuVXe~
---------------------------------------------------------------------------------------------------------------------*/
C_RESULT ardrone_tool_shutdown()
{
	C_RESULT res = C_OK;

	#ifndef NO_ARDRONE_MAINLOOP
		res = ardrone_tool_shutdown_custom();
	#endif

	// TuVXẽVbg_E
	ardrone_navdata_client_shutdown();
	ardrone_control_shutdown();
	ardrone_tool_input_shutdown();

	JOIN_THREAD(ardrone_control); 
	JOIN_THREAD(navdata_update);

	// ATR}h̃Vbg_E
	ATcodec_exit_thread();
	ATcodec_Shutdown_Library();

	vp_com_disconnect(COM_NAVDATA());
	vp_com_shutdown(COM_NAVDATA());

	printf("custom ardrone tool I\n");

	return res;
}


/*---------------------------------------------------------------------------------------------------------------------
ARDroneƂ̃lbg[Nڑ̃eXg
ARDroneɂFTPT[o[oRARDronẽo[WԍĂяoD
FreeFlightCARDronẽ\tgEFA̍XVKvǂ𒲂ׂ@D
̃R[h͂Ȃ蔲ŉDFTPpbVu[hgĂD
---------------------------------------------------------------------------------------------------------------------*/
int test_drone_connection()
{
	const char * passivdeModeHeader = "\r\n227 PASV ok (";
	vp_com_socket_t ftp_client,ftp_client2;
	char buffer[1024];
	static Write ftp_write = NULL;
	static Read  ftp_read = NULL;
	int bytes_to_send,received_bytes;
	int i, L, x[6], port;

	vp_os_memset(buffer,0,sizeof(buffer));

	// FTPT[oւ̐ڑ
	wifi_config_socket(&ftp_client,VP_COM_CLIENT,FTP_PORT,WIFI_ARDRONE_IP);
	ftp_client.protocol = VP_COM_TCP;
	if (VP_FAILED(vp_com_init(wifi_com()))) return -1;
	if (VP_FAILED(vp_com_open(wifi_com(), &ftp_client, &ftp_read, &ftp_write))) return -2;

	// o[Wt@Cv
	bytes_to_send = sprintf_s( buffer, sizeof(buffer), "%s", "USER anonymous\r\nCWD /\r\nPWD\r\nTYPE A\r\nPASV\r\nRETR version.txt\r\n" );

	ftp_write( &ftp_client, (int8_t*)buffer, &bytes_to_send );
	Sleep(1000);	// 蔲D{͓\Pbg̃ubLOŃf[^̂҂ȂƂȂD

	// f[^|[g擾
	received_bytes = sizeof(buffer);
	ftp_read( &ftp_client, (int8_t*)buffer, &received_bytes );
	if (received_bytes<1) {
		vp_com_close(wifi_com(), &ftp_client);
		return -3;
	}
	L = received_bytes - strlen(passivdeModeHeader);

	// FTPT[õpbVu[h̏F
	for (i=0;i<L;i++) {
		if (strncmp((buffer+i),passivdeModeHeader,strlen(passivdeModeHeader))==0)  break; 
	}
	if (i==L) {
		vp_com_close(wifi_com(), &ftp_client); return -4; 
	}
	i += strlen(passivdeModeHeader);
	if ( sscanf_s( buffer+i,"%i,%i,%i,%i,%i,%i)",&x[0],&x[1],&x[2],&x[3],&x[4],&x[5]) != 6 ) {
		vp_com_close(wifi_com(), &ftp_client);
		return -5;
	}
	port = (x[4]<<8) + x[5];

	// FTPT[oɐڑ
	wifi_config_socket(&ftp_client2,VP_COM_CLIENT,port,"192.168.1.1");
	ftp_client2.protocol = VP_COM_TCP;
	if (VP_FAILED(vp_com_init(wifi_com()))) {
		vp_com_close(wifi_com(), &ftp_client2);
		return -6;
	}
	if (VP_FAILED(vp_com_open(wifi_com(), &ftp_client2, &ftp_read, &ftp_write))) {
		vp_com_close(wifi_com(), &ftp_client2);
		return -7;
	}

	// f[^̎擾
	received_bytes = sizeof(buffer);
	ftp_read( &ftp_client2, (int8_t*)buffer, &received_bytes );
	if (received_bytes>0) {
		buffer[min(received_bytes,sizeof(buffer)-1)] = 0;
		printf( "ARDronẽo[W擾F%s\n", buffer );
	}

	// N[Abv
	vp_com_close(wifi_com(), &ftp_client);
	vp_com_close(wifi_com(), &ftp_client2);

	return 0;
}


/*---------------------------------------------------------------------------------------------------------------------
main֐
---------------------------------------------------------------------------------------------------------------------*/
int main(int argc, char **argv)
{
	C_RESULT res;
	WSADATA wsaData = {0};
	int iResult = 0;

	// \Pbg̏
	iResult = WSAStartup(MAKEWORD(2, 2), &wsaData);
	if (iResult != 0) {
		printf("\Pbg̏Ɏs܂D\n");
		return -1;
	}
	res = test_drone_connection();
	if (res != 0) {
		WSACleanup();
		printf("%s","ARdrone܂D\n");
		return -1;
	}
	res = ardrone_tool_setup_com(NULL);
	if (FAILED(res)) {
		printf("WifȉɎs܂D\n");
		return -1;
	}

	printf("EnterL[ƃAvP[VJn܂D\n");
	getchar();

	// ARDrone Tool̏
	res = ardrone_tool_init(argc, argv);

	// ARDroneɓĂATR}h𑗂葱
	while ( VP_SUCCEEDED(res) && ardrone_tool_exit() == FALSE ) {
		res = ardrone_tool_update();     
	}

	// I
	res = ardrone_tool_shutdown();
	WSACleanup();

	return VP_SUCCEEDED(res) ? 0 : -1;
}
