
#include <config.h>
#include <ardrone_api.h>
#include <ATcodec/ATcodec_api.h>

#include <ardrone_tool/ardrone_time.h>
#include <ardrone_tool/Navdata/ardrone_navdata_client.h>
#include <ardrone_tool/Control/ardrone_control.h>
#include <ardrone_tool/UI/ardrone_input.h>

#include <VP_Os/vp_os_types.h>
#include <VP_Os/vp_os_print.h>
#include <VP_Api/vp_api_thread_helper.h>
#include <VP_Os/vp_os_signal.h>

#define GLOBAL_DEFINE_EXIT_VALUE
#include "custom_code.h"

#include "controller.h"
#include "video_stage.h"
#include "image_processing.h"


// Xbh̒`
BEGIN_THREAD_TABLE
	THREAD_TABLE_ENTRY( ardrone_control, 20 )	// ardrone_controlSDKŒ`ς݂̃Xbh
	THREAD_TABLE_ENTRY( navdata_update, 20 )	// navdata_updateSDKŒ`ς݂̃Xbh
	THREAD_TABLE_ENTRY( video_stage, 20 )
	THREAD_TABLE_ENTRY( opencv_thread, 20 )
END_THREAD_TABLE


// [U`̏֐
C_RESULT ardrone_tool_init_custom(int argc, char **argv)
{
	// R\[̃^Cgo[ύX
	SetConsoleTitle(TEXT("AR.Drone Demo for Windows"));

	// ̓foCX̓o^
	ardrone_tool_input_add( &dx_keyboard );

	// Xbh̃X^[g
	START_THREAD( opencv_thread , NULL);
	START_THREAD( video_stage, NULL );

	return C_OK;
}


// [U`̃Abvf[g֐
C_RESULT ardrone_tool_update_custom()
{
	return C_OK;
}


// [U`̃fBXvC֐
C_RESULT ardrone_tool_display_custom()
{
	return C_OK;
}


// [U`̏I֐
C_RESULT ardrone_tool_shutdown_custom()
{
	// Xbh̏I
	JOIN_THREAD( opencv_thread );
	JOIN_THREAD( video_stage );
	ardrone_tool_input_remove( &dx_keyboard );

	return C_OK;
}


// [U`̏IԊmF֐
bool_t ardrone_tool_exit()
{
	return g_exit_is_requested;
}


// Iʒm֐
C_RESULT signal_exit()
{
	g_exit_is_requested = TRUE;
	return C_OK;
}
