

#include <stdio.h>
#include <VLIB/Stages/vlib_stage_decode.h>
#include <VP_Stages/vp_stages_yuv2rgb.h>
#include <ardrone_tool/Com/config_com.h>
#include <ardrone_tool/UI/ardrone_input.h>
#include <ardrone_tool/Video/video_com_stage.h>

#include <win32_custom.h>
#include "video_stage.h"
#include "converter.h"


// O[o
static vp_os_mutex_t video_update_lock;	// mutex


// ֐
C_RESULT video_open( void *cfg, vp_api_io_data_t *in, vp_api_io_data_t *out)
{
	vp_os_mutex_init(&video_update_lock);	// mutex̏
	return VP_SUCCESS;
}


// XV֐
C_RESULT video_transform( void *cfg, vp_api_io_data_t *in, vp_api_io_data_t *out)
{
	vlib_stage_decoding_config_t* vec = (vlib_stage_decoding_config_t*)cfg;
	uint8_t* p_image = NULL;

	vp_os_mutex_lock(&video_update_lock);	// mutexbN
	p_image = (uint8_t*)in->buffers[0];		// ŌɃfR[hꂽ摜ւ̃|C^擾

	// obt@ϊ
	ConvertImage( p_image, DRONE_VIDEO_MAX_WIDTH, DRONE_VIDEO_MAX_HEIGHT,
				  vec->controller.width, vec->controller.height );

	vp_os_mutex_unlock(&video_update_lock);	// mutex

	return VP_SUCCESS;
}


// I֐
C_RESULT video_close( void *cfg, vp_api_io_data_t *in, vp_api_io_data_t *out)
{
	return VP_SUCCESS;
}


// ֐Xg
static const vp_api_stage_funcs_t g_video_funcs = {
	NULL,
	(vp_api_stage_open_t) video_open,
	(vp_api_stage_transform_t) video_transform,
	(vp_api_stage_close_t) video_close
};


// rfIsXbh
DEFINE_THREAD_ROUTINE(video_stage, data)
{
	PIPELINE_HANDLE					pipeline_handle;
	C_RESULT						res;
	vp_api_io_pipeline_t		    pipeline;
	vp_api_io_data_t			    out;
	vp_api_io_stage_t			    stages[10];
	vp_api_picture_t				picture;
	video_com_config_t              icc;
	vlib_stage_decoding_config_t    vec;
	vp_stages_yuv2rgb_config_t      yuv2rgbconf;

	printf("video_stageXbhJn\n");

	// 摜̐ݒ
	picture.format		= PIX_FMT_YUV420P;
	picture.width		= DRONE_VIDEO_MAX_WIDTH;
	picture.height		= DRONE_VIDEO_MAX_HEIGHT;
	picture.framerate	= 15;

	// obt@̎擾
	picture.y_buf   = (uint8_t*)vp_os_malloc( DRONE_VIDEO_MAX_WIDTH * DRONE_VIDEO_MAX_HEIGHT     );
	picture.cr_buf  = (uint8_t*)vp_os_malloc( DRONE_VIDEO_MAX_WIDTH * DRONE_VIDEO_MAX_HEIGHT / 4 );
	picture.cb_buf  = (uint8_t*)vp_os_malloc( DRONE_VIDEO_MAX_WIDTH * DRONE_VIDEO_MAX_HEIGHT / 4 );

	picture.y_line_size   = DRONE_VIDEO_MAX_WIDTH;
	picture.cb_line_size  = DRONE_VIDEO_MAX_WIDTH / 2;
	picture.cr_line_size  = DRONE_VIDEO_MAX_WIDTH / 2;

	// [
	vp_os_memset(&icc,          0, sizeof( icc ));
	vp_os_memset(&vec,          0, sizeof( vec ));
	vp_os_memset(&yuv2rgbconf,  0, sizeof( yuv2rgbconf ));

	// rfI\Pbg̐ݒ
	icc.com                 = COM_VIDEO();
	icc.buffer_size         = 100000;
	icc.protocol            = VP_COM_UDP;

	COM_CONFIG_SOCKET_VIDEO( &icc.socket, VP_COM_CLIENT, VIDEO_PORT, wifi_ardrone_ip );

	// rfIfR[_̐ݒ
	// obt@̃TCY͍őlɂ邱ƁD
	// ۂ̉𑜓x̓fR[_ɂvec.controllerɓ
	vec.width               = DRONE_VIDEO_MAX_WIDTH;
	vec.height              = DRONE_VIDEO_MAX_HEIGHT;
	vec.picture             = &picture;
	vec.block_mode_enable   = TRUE;
	vec.luma_only           = FALSE;

	yuv2rgbconf.rgb_format = VP_STAGES_RGB_FORMAT_RGB24;

	// rfIXg[̎󂯓
	pipeline.nb_stages = 0;
	stages[pipeline.nb_stages].type    = VP_API_INPUT_SOCKET;
	stages[pipeline.nb_stages].cfg     = (void *)&icc;
	stages[pipeline.nb_stages].funcs   = video_com_funcs;

	// rfIXg[̃fR[h
	pipeline.nb_stages++;
	stages[pipeline.nb_stages].type    = VP_API_FILTER_DECODER;
	stages[pipeline.nb_stages].cfg     = (void*)&vec;
	stages[pipeline.nb_stages].funcs   = vlib_decoding_funcs;

	// YUV->RGBϊ
	// YUVtH[}bg̓rfIXg[vgRɂĎgD
	// YUV𒼐ڈł΁C͕̏Kv͂ȂD
	pipeline.nb_stages++;
	stages[pipeline.nb_stages].type    = VP_API_FILTER_YUV2RGB;
	stages[pipeline.nb_stages].cfg     = (void*)&yuv2rgbconf;
	stages[pipeline.nb_stages].funcs   = vp_stages_yuv2rgb_funcs;

	// [UR[h
	pipeline.nb_stages++;
	stages[pipeline.nb_stages].type    = VP_API_OUTPUT_SDL;	// SDLgĂȂĂVP_API_OUTPUT_SDLZbg
	stages[pipeline.nb_stages].cfg     = (void*)&vec;		// _ɃfR[_̏^
	stages[pipeline.nb_stages].funcs   = g_video_funcs;

	pipeline.nb_stages++;
	pipeline.stages = &stages[0];

	// pCvC̏
	if ( !ardrone_tool_exit() ) {
		res = vp_api_open(&pipeline, &pipeline_handle);
		if ( VP_SUCCEEDED(res) ) {
			int loop = VP_SUCCESS;
			out.status = VP_API_STATUS_PROCESSING;
			// AR.Drone胋[v
			while ( !ardrone_tool_exit() && (loop == VP_SUCCESS) ) {
				if ( VP_SUCCEEDED(vp_api_run(&pipeline, &out)) ) {
					if ( (out.status == VP_API_STATUS_PROCESSING || out.status == VP_API_STATUS_STILL_RUNNING) ) {
						loop = VP_SUCCESS;
					}
				}
				else {
					loop = -1;	// ̃XbhI
				}
			}
			vp_api_close(&pipeline, &pipeline_handle);
		}
	}

	printf("video_stageXbhI\n");

	return (THREAD_RET) 0;
}

